import { IRestEntity } from '@jacquesparis/objects-model';
import { Provider } from '@loopback/core';
import { ApplicationService, CurrentContext } from './../application.service';
import { EntityInterceptService } from './../entity-intercept/entity-intercept.service';
import { InsideRestDataSource } from './inside-rest.datasource';
export interface InsideRestRepository {
    read(uri: string, authorization: string, acceptLanguage: string, sessionid: string | undefined): Promise<IRestEntity>;
}
export declare class InsideRestRepositoryProvider implements Provider<InsideRestRepository> {
    protected dataSource: InsideRestDataSource;
    constructor(dataSource?: InsideRestDataSource);
    value(): Promise<InsideRestRepository>;
}
declare class InsideRestContext {
    id?: string;
    copyToChildContext: boolean;
    loadedUris: {
        [uri: string]: object;
    };
}
export declare class InsideRestService {
    private insideRestRepository;
    private entityInterceptService;
    private applicationService;
    private insideRestInterceptor;
    private insideRestFinalTreatment;
    get runningRequestLoadedUris(): {
        [id: string]: {
            [uri: string]: object;
        };
    };
    constructor(insideRestRepository: InsideRestRepository, entityInterceptService: EntityInterceptService, applicationService: ApplicationService);
    getOpenedSessionId(ctx: CurrentContext): string | undefined;
    startSharedResults(ctx: CurrentContext): void;
    endSharedResults(ctx: CurrentContext): void;
    private getCtx;
    getLoadedEntity(uriId: string, insideRestCtx: InsideRestContext): IRestEntity;
    setLoadedEntity(entity: IRestEntity, uriId: string, insideRestCtx: InsideRestContext): IRestEntity;
    read(uri: string, ctx: CurrentContext, forceNewRead?: boolean): Promise<IRestEntity>;
}
export {};
